package cn.estsh.i3plus.core.apiservice.controller;

import cn.estsh.impp.framework.boot.fastdfs.FastDFSClient;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.servlet.mvc.support.RedirectAttributes;

/**
 * @Description :
 * @Reference :
 * @Author : alwaysfrin
 * @CreateDate : 2018-09-28 11:20
 * @Modify:
 **/
@Controller
@RequestMapping("/demo-upload")
@Api(description="复杂对象服务demo")
public class DemoUploadController {
    private static final Logger LOGGER = LoggerFactory.getLogger(DemoUploadController.class);

    /********************** 文件上传 ***********************/

    @Autowired
    private FastDFSClient dfsClient;

    @GetMapping("/")
    public String index() {
        return "/index";
    }

    @GetMapping("/index")
    public String indexAgain() {
        return "/index";
    }

    @GetMapping("/upfile")
    public String indexUpload() {
        return "/upload";
    }

    @GetMapping("/upload-status")
    public String uploadStatus() {
        return "/upload-status";
    }

    @PostMapping("/upload")
    @ApiOperation(value = "文件上传",notes = "文件上传")
    public String singleFileUpload(@RequestParam("file") MultipartFile file, RedirectAttributes redirectAttributes) {
        if (file.isEmpty()) {
            redirectAttributes.addFlashAttribute("message", "请选择需要上传的文件。");
            return "redirect:/demo-upload/uploadStatus";
        }
        try {
            // Get the file and save it somewhere
            String path = dfsClient.saveFile(file);
            redirectAttributes.addFlashAttribute("message","文件上传成功 '" + file.getOriginalFilename() + "'");
            redirectAttributes.addFlashAttribute("path","url路径 '" + path + "'");
        } catch (Exception e) {
            LOGGER.error("upload file failed",e);
        }
        return "redirect:/demo-upload/uploadStatus";
    }
}
